/*
 * Copyright (C) 2004 emuWorks
 * http://games.technoplaza.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _CHT_CODE_HH
#define _CHT_CODE_HH

#include <wx/wxprec.h>

#ifndef WX_PRECOMP
   #include <wx/wx.h>
#endif

namespace wxCHTDecoder {
    class CHTCode {
    public:
        CHTCode(wxString &, int, int, bool);
        CHTCode(const CHTCode &);
        ~CHTCode();
    
        static CHTCode parseCHTData(const char *data);
    
        const wxString &getName() const { return *name; }
        
        void setName(const wxString &name) {
            if (this->name) {
                delete this->name;
            }
        
            this->name = new wxString(name);
        }
    
        int getAddress() const { return address; }
        
        void setAddress(int address) {
            if ((address & 0xFF000000) == 0) { 
                this->address = address;
            }
        }
    
        int getValue() const { return value; }
    
        void setValue(int value) {
            if ((value & 0xFFFFFF00) == 0) {
                this->value = value;
            }
        }
    
        bool isActive() const { return active; }
        void setActive(bool active) { this->active = active; }
        
        wxString toString();
    private:
        wxString *name;
        int address, value;
        bool active;
    };
}

#endif

